﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ThinkGeo.MapSuite.WebEdition;
using ThinkGeo.MapSuite.Core;


namespace MS_OSPFM
{
    public partial class MarkerWithLabel : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                //btnMeasureLine.Attributes.Add("onclick", "activate()");
                //btnNormal.Attributes.Add("onclick", "deactivate()");

                #region Set Map Properties and values
                string sUnit = "Meter";
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"));
                Map1.CurrentExtent = new RectangleShape(-13939426.6371, 6701997.4056, -7812401.86, 2626987.386962);
                Map1.MapTools.PanZoom.Enabled = false;
                Map1.MapTools.PanZoomBar.Enabled = true;
                Map1.MapUnit = (GeographyUnit)Enum.Parse(typeof(GeographyUnit), sUnit);

                LayerOverlay layerOverLay = new LayerOverlay("OSPFM Layers");
                layerOverLay.IsBaseOverlay = false;
                layerOverLay.ClientCache.CacheId = "OSPFM_Layers";
                layerOverLay.TransitionEffect = TransitionEffect.None;
                layerOverLay.TileType = TileType.SingleTile;
                layerOverLay.Layers.Clear();

                //# end of Map properties
                #endregion

                //15 - Load Access_Point
                ShapeFileFeatureLayer lyr_points_Access_Point = new ShapeFileFeatureLayer(Server.MapPath("~/Data/Access_Points.shp"));
                lyr_points_Access_Point.ZoomLevelSet.ZoomLevel18.DefaultPointStyle = PointStyles.CreateSimplePointStyle(PointSymbolType.Square, GeoColor.SimpleColors.Blue, 15f);
                lyr_points_Access_Point.ZoomLevelSet.ZoomLevel18.DefaultTextStyle = TextStyles.City1("TYPE_NAME");
                lyr_points_Access_Point.ZoomLevelSet.ZoomLevel18.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                lyr_points_Access_Point.DrawingMarginPercentage = 50;

                lyr_points_Access_Point.Close();

                //3 - Load Fiber_Security_Aerial.shp
                ShapeFileFeatureLayer lyr_lines_Buried_Cable = new ShapeFileFeatureLayer(Server.MapPath("~/Data/Fiber_Security_Aerial.shp"));
                lyr_lines_Buried_Cable.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.StandardColors.Crimson, 2f, true);
                lyr_lines_Buried_Cable.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = TextStyles.Pipeline1("LABEL");
                lyr_lines_Buried_Cable.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                lyr_lines_Buried_Cable.DrawingMarginPercentage = 50;

                Proj4Projection proj4_points_Access_Points = new Proj4Projection();
                proj4_points_Access_Points.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
                proj4_points_Access_Points.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
                lyr_points_Access_Point.FeatureSource.Projection = proj4_points_Access_Points;

                Proj4Projection proj4_lines_Buried_Cable = new Proj4Projection();
                proj4_lines_Buried_Cable.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
                proj4_lines_Buried_Cable.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
                lyr_lines_Buried_Cable.FeatureSource.Projection = proj4_lines_Buried_Cable;

                layerOverLay.Layers.Add("Lyr_Access_Point", lyr_points_Access_Point);
                layerOverLay.Layers.Add("Lyr_Buried_Cable", lyr_lines_Buried_Cable);

                VirtualEarthOverlay ve = new VirtualEarthOverlay("VirtualEarth Map");
                ve.VirtualEarthMapType = VirtualEarthMapType.Birdseye;

                Map1.CustomOverlays.Clear();
                Map1.CustomOverlays.Add(layerOverLay);
                Map1.CustomOverlays.Add(ve);

            }
        }
    }
}
